<p>XML External Entity (XXE) attacks are similar to XSS attacks in terms of injecting malicious code, though the target is XML documents. The vulnerability is exploited by abusing the XML parsing engine; in Python, that's usually the built-in <code>xml</code> library. The gist of the attack is including type definitions into the XML document (or HTTP request done in the form of XML, like SOAP calls).</p>
<p>In the type definition, the attacker places a call to an external site, controlled by them, or may include files from the local file system. As you may have recognized, this can easily turn into a Local File Inclusion attack. I.e., the attacker could get a sensitive file (like configuration or password) by combining the attacks, forming an attack chain.</p>
<p>In case of edx-platform, we use XML in the course structure, XBlocks and more. When a course is exported, the asset definitions, course info, sections, etc., are all in XML. Therefore, there is a potential for XXE attacks too. As we have already seen in the previous section, the course import is already vulnerable.<span style="color: #000000;"> </span></p>
<p><span style="color: #000000;"><span style="color: #000000;">An XXE attack against an XML document (or API request), could be carried out, abusing the fields used. Let's take the following example from course exports (this is not the actual course structure!). Below there is a course chapter.</span></span></p>
<p><span><span style="color: #000000;"></span></span></p>
<blockquote>
<p><span style="color: #000000;">&lt;chapter display_name="Basic Vulnerabilities"/&gt;</span></p>
</blockquote>
<p><span style="color: #000000;">The chapter is a very simple example. If the course chapter parsing would be vulnerable for XXE attacks, the attacker would do something similar to get some sensitive data out of the environment:</span></p>
<blockquote>
<p><code>&lt;?xml version="1.0"?&gt;<br /></code><code>&lt;!DOCTYPE chapter [ &lt;!ENTITY shadow SYSTEM "file:///etc/shadow'"&gt; ]&gt; <br />&lt;chapter display_name="Basic Vulnerabilities"&gt; &amp;shadow; &lt;/chapter&gt;</code></p>
</blockquote>
<p>If that was an actually working course chapter structure, the <code>/etc/shadow</code> file would have been printed somewhere around the course chapter name. Although it is about XML, we really mean any entity that can be described in XML, this includes SVGs too. Giving a little example, the XXE attack could be carried out in SVG entities like below:</p>
<blockquote>
<p><code><span style="font-family: 'Open Sans', Verdana, Arial, Helvetica, sans-serif;"><span style="font-family: monospace, serif;">&lt;?xml version="1.0" encoding="UTF-8"?&gt; &lt;!DOCTYPE svg [ &lt;!ENTITY xxe SYSTEM "file:///etc/shadow"&gt; ]&gt;<br /></span></span></code><code><span style="font-family: 'Open Sans', Verdana, Arial, Helvetica, sans-serif;"><span style="font-family: monospace, serif;">&lt;svg&gt;&amp;xxe;&lt;/svg&gt;</span></span></code></p>
</blockquote>
<p>Of course, there are other, more complex techniques that could be applied by an attacker to include remote type definitions and execute attacks in less iterations. However, our goal is to prevent these, not to practice them.</p>
<p><code><span style="font-family: 'Open Sans', Verdana, Arial, Helvetica, sans-serif;"><span style="background-color: #ffffff;"><span style="font-family: Open Sans, Verdana, Arial, Helvetica, sans-serif;">Exploiting attacks using XXE requires the attacker to write the content of the XML entities, not their attributes. Attributes cannot reference values from definitions. Therefore, we can prevent these attacks by keeping the parsing library up-to-date, taking extra care when sanitizing values from XML input, and, even though not the most sophisticated, we can use attributes almost all the time and not parse the entity body.</span></span><span style="font-family: monospace, serif;"></span></span></code></p>